/**
  *******************************************************************************************************
  * @file    ads1232.h
  * @author  Erisson Siqueira
  * @brief   Test Version
  *******************************************************************************************************
 */
 
#ifndef __ADS1232
#define __ADS1232

/* Includes --------------------------------------------------------------------------------------------*/											
#include "stm32f1xx_hal.h"
														
/* Defines ---------------------------------------------------------------------------------------------*/
#define	MAX_BUFFER		40

#define A0(x)			((x)?	(HAL_GPIO_WritePin(ADS1232_A0_GPIO_Port, ADS1232_A0_Pin, GPIO_PIN_SET)):\
												(HAL_GPIO_WritePin(ADS1232_A0_GPIO_Port, ADS1232_A0_Pin, GPIO_PIN_RESET)));

#define SCLK(x)		((x)?	(HAL_GPIO_WritePin(ADS1232_SCK_GPIO_Port, ADS1232_SCK_Pin, GPIO_PIN_SET)):\
												(HAL_GPIO_WritePin(ADS1232_SCK_GPIO_Port, ADS1232_SCK_Pin, GPIO_PIN_RESET)));

#define SPEED(x)	((x)?	(HAL_GPIO_WritePin(ADS1232_SPEED_GPIO_Port, ADS1232_SPEED_Pin, GPIO_PIN_SET)):\
												(HAL_GPIO_WritePin(ADS1232_SPEED_GPIO_Port, ADS1232_SPEED_Pin, GPIO_PIN_RESET)));

#define PDOWN(x)	((x)?	(HAL_GPIO_WritePin(ADS1232_PDOWN_GPIO_Port, ADS1232_PDOWN_Pin, GPIO_PIN_SET)):\
												(HAL_GPIO_WritePin(ADS1232_PDOWN_GPIO_Port, ADS1232_PDOWN_Pin, GPIO_PIN_RESET)));

#define GAIN_1(x)	((x)?	(HAL_GPIO_WritePin(ADS1232_GAIN1_GPIO_Port, ADS1232_GAIN1_Pin, GPIO_PIN_SET)):\
												(HAL_GPIO_WritePin(ADS1232_GAIN1_GPIO_Port, ADS1232_GAIN1_Pin, GPIO_PIN_RESET)));

#define GAIN_0(x)	((x)?	(HAL_GPIO_WritePin(ADS1232_GAIN0_GPIO_Port, ADS1232_GAIN0_Pin, GPIO_PIN_SET)):\
												(HAL_GPIO_WritePin(ADS1232_GAIN0_GPIO_Port, ADS1232_GAIN0_Pin, GPIO_PIN_RESET)));

#define DOUT_READ_BIT			HAL_GPIO_ReadPin(ADS1232_DOUT_GPIO_Port, ADS1232_DOUT_Pin)


/* Variables -------------------------------------------------------------------------------------------*/		

/* Structs ---------------------------------------------------------------------------------------------*/

/* Function Prototypes ---------------------------------------------------------------------------------*/
void 	Start(void);
void 	Calib(void);
void 	Read(void);
void 	Delay_ms (int delay);
void 	Delay_us (int delay);

#endif

